/**
 *  Copyright 2012 GroupDocs.
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */
package com.groupdocs.sdk.model;

import java.util.*;
import com.groupdocs.sdk.model.SignatureEnvelopeRecipientInfo;
/**
 * 
 * <p>
 * NOTE: This class is auto generated by the swagger code generator program. Do not edit the class manually.
 *
 */
public class SignatureEnvelopeInfo {
  private String id = null;
  private String name = null;
  private String creationDateTime = null;
  private String updatedDateTime = null;
  private String ownerGuid = null;
  private Integer status = null;
  private String statusDateTime = null;
  private Double reminderTime = null;
  private Double stepExpireTime = null;
  private Double envelopeExpireTime = null;
  private Boolean ownerShouldSign = null;
  private Boolean orderedSignature = null;
  private String emailSubject = null;
  private String emailBody = null;
  private Double documentsCount = null;
  private Double documentsPages = null;
  private List<SignatureEnvelopeRecipientInfo> recipients = new ArrayList<SignatureEnvelopeRecipientInfo>();
  private String waterMarkText = null;
  private String waterMarkImage = null;
  private Boolean attachSignedDocument = null;
  private Boolean includeViewLink = null;
  private Boolean canBeCommented = null;
  private Boolean inPersonSign = null;
  public String getId() {
    return id;
  }
  public void setId(String id) {
    this.id = id;
  }

  public String getName() {
    return name;
  }
  public void setName(String name) {
    this.name = name;
  }

  public String getCreationDateTime() {
    return creationDateTime;
  }
  public void setCreationDateTime(String creationDateTime) {
    this.creationDateTime = creationDateTime;
  }

  public String getUpdatedDateTime() {
    return updatedDateTime;
  }
  public void setUpdatedDateTime(String updatedDateTime) {
    this.updatedDateTime = updatedDateTime;
  }

  public String getOwnerGuid() {
    return ownerGuid;
  }
  public void setOwnerGuid(String ownerGuid) {
    this.ownerGuid = ownerGuid;
  }

  public Integer getStatus() {
    return status;
  }
  public void setStatus(Integer status) {
    this.status = status;
  }

  public String getStatusDateTime() {
    return statusDateTime;
  }
  public void setStatusDateTime(String statusDateTime) {
    this.statusDateTime = statusDateTime;
  }

  public Double getReminderTime() {
    return reminderTime;
  }
  public void setReminderTime(Double reminderTime) {
    this.reminderTime = reminderTime;
  }

  public Double getStepExpireTime() {
    return stepExpireTime;
  }
  public void setStepExpireTime(Double stepExpireTime) {
    this.stepExpireTime = stepExpireTime;
  }

  public Double getEnvelopeExpireTime() {
    return envelopeExpireTime;
  }
  public void setEnvelopeExpireTime(Double envelopeExpireTime) {
    this.envelopeExpireTime = envelopeExpireTime;
  }

  public Boolean getOwnerShouldSign() {
    return ownerShouldSign;
  }
  public void setOwnerShouldSign(Boolean ownerShouldSign) {
    this.ownerShouldSign = ownerShouldSign;
  }

  public Boolean getOrderedSignature() {
    return orderedSignature;
  }
  public void setOrderedSignature(Boolean orderedSignature) {
    this.orderedSignature = orderedSignature;
  }

  public String getEmailSubject() {
    return emailSubject;
  }
  public void setEmailSubject(String emailSubject) {
    this.emailSubject = emailSubject;
  }

  public String getEmailBody() {
    return emailBody;
  }
  public void setEmailBody(String emailBody) {
    this.emailBody = emailBody;
  }

  public Double getDocumentsCount() {
    return documentsCount;
  }
  public void setDocumentsCount(Double documentsCount) {
    this.documentsCount = documentsCount;
  }

  public Double getDocumentsPages() {
    return documentsPages;
  }
  public void setDocumentsPages(Double documentsPages) {
    this.documentsPages = documentsPages;
  }

  public List<SignatureEnvelopeRecipientInfo> getRecipients() {
    return recipients;
  }
  public void setRecipients(List<SignatureEnvelopeRecipientInfo> recipients) {
    this.recipients = recipients;
  }

  public String getWaterMarkText() {
    return waterMarkText;
  }
  public void setWaterMarkText(String waterMarkText) {
    this.waterMarkText = waterMarkText;
  }

  public String getWaterMarkImage() {
    return waterMarkImage;
  }
  public void setWaterMarkImage(String waterMarkImage) {
    this.waterMarkImage = waterMarkImage;
  }

  public Boolean getAttachSignedDocument() {
    return attachSignedDocument;
  }
  public void setAttachSignedDocument(Boolean attachSignedDocument) {
    this.attachSignedDocument = attachSignedDocument;
  }

  public Boolean getIncludeViewLink() {
    return includeViewLink;
  }
  public void setIncludeViewLink(Boolean includeViewLink) {
    this.includeViewLink = includeViewLink;
  }

  public Boolean getCanBeCommented() {
    return canBeCommented;
  }
  public void setCanBeCommented(Boolean canBeCommented) {
    this.canBeCommented = canBeCommented;
  }

  public Boolean getInPersonSign() {
    return inPersonSign;
  }
  public void setInPersonSign(Boolean inPersonSign) {
    this.inPersonSign = inPersonSign;
  }

  @Override
  public String toString()  {
    StringBuilder sb = new StringBuilder();
    sb.append("class SignatureEnvelopeInfo {\n");
    sb.append("  id: ").append(id).append("\n");
    sb.append("  name: ").append(name).append("\n");
    sb.append("  creationDateTime: ").append(creationDateTime).append("\n");
    sb.append("  updatedDateTime: ").append(updatedDateTime).append("\n");
    sb.append("  ownerGuid: ").append(ownerGuid).append("\n");
    sb.append("  status: ").append(status).append("\n");
    sb.append("  statusDateTime: ").append(statusDateTime).append("\n");
    sb.append("  reminderTime: ").append(reminderTime).append("\n");
    sb.append("  stepExpireTime: ").append(stepExpireTime).append("\n");
    sb.append("  envelopeExpireTime: ").append(envelopeExpireTime).append("\n");
    sb.append("  ownerShouldSign: ").append(ownerShouldSign).append("\n");
    sb.append("  orderedSignature: ").append(orderedSignature).append("\n");
    sb.append("  emailSubject: ").append(emailSubject).append("\n");
    sb.append("  emailBody: ").append(emailBody).append("\n");
    sb.append("  documentsCount: ").append(documentsCount).append("\n");
    sb.append("  documentsPages: ").append(documentsPages).append("\n");
    sb.append("  recipients: ").append(recipients).append("\n");
    sb.append("  waterMarkText: ").append(waterMarkText).append("\n");
    sb.append("  waterMarkImage: ").append(waterMarkImage).append("\n");
    sb.append("  attachSignedDocument: ").append(attachSignedDocument).append("\n");
    sb.append("  includeViewLink: ").append(includeViewLink).append("\n");
    sb.append("  canBeCommented: ").append(canBeCommented).append("\n");
    sb.append("  inPersonSign: ").append(inPersonSign).append("\n");
    sb.append("}\n");
    return sb.toString();
  }
}

